/* The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef _GANDI_WM_H

#define _GANDI_WM_H	1

#include "gandi_core.h"

/*	system mode keys */
#define GANDI_wm_keymap_move	1
#define GANDI_wm_keymap_resize	2
/*	system navigate keys */
#define GANDI_wm_keymap_KEY_UP		16
#define GANDI_wm_keymap_KEY_DOWN	17
#define GANDI_wm_keymap_KEY_LEFT	18
#define GANDI_wm_keymap_KEY_RIGHT	19
#define GANDI_wm_keymap_KEY_RETURN	20

/*	the keymap_sys of the proceeding widget */
extern GANDIT_keymap **GANDI_wm_keymap_proc;

/*	the first function you've to call to use this library */
extern int GANDI_wm_init();
/*	replaces GANDI_dfl_syskey_driver */
extern GANDIT_drvret GANDI_wm_driver(int val);
/*	puts w into move mode */
extern void GANDI_wm_move(int val);
/*	puts w into resize mode */
extern void GANDI_wm_resize(int val);

#endif /* gandi_wm.h */

