/* The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef _GANDIW_PUSH_BUTTON_H

#define _GANDIW_PUSH_BUTTON_H		1

#include "gandiw_text_label.h"

typedef struct _GANDIW_push_button GANDIW_push_button;
typedef void(* GANDIW_push_button_act_push)(GANDIW_push_button *);

struct _GANDIW_push_button {
	GANDIW_widget *			core;	/* common for all widgets */
	GANDIW_text_label *		capwid;
	attr_t				win_attr;
	short				win_pair;
	attr_t				toggle_attr;
	short				toggle_pair;
	short				toggle;
	struct {
	GANDIW_push_button_act_push	push;	/* push handler */
	} act;
};

extern GANDIW_widget GANDIW_push_button_dfl_core;
extern GANDIW_push_button GANDIW_push_button_dfl;

extern GANDIW_push_button *GANDIW_push_button_make(int nlines, int ncols,		int by, int bx, void *parent, const chtype *caption);
extern int GANDIW_push_button_resize(GANDIW_push_button *w, int nlines,			int ncols, int by, int bx);
extern void GANDIW_push_button_show(GANDIW_push_button *w);
extern void GANDIW_push_button_refresh(GANDIW_push_button *w);
short GANDIW_push_button_set_some_pair(GANDIW_push_button *w, short *dest,		short val);
attr_t GANDIW_push_button_set_some_attr(GANDIW_push_button *w, attr_t *dest,		attr_t val);
extern int GANDIW_push_button_driver(GANDIW_push_button *w, int k);

#define GANDIW_push_button_vtw(w)	( (GANDIW_push_button *)w )

#define GANDIW_push_button_caption(w)							( (GANDIW_text_label *)(GANDIW_push_button_vtw(w)->capwid) )
#define GANDIW_push_button_get_capwid(w) GANDIW_push_button_caption(w)

#define GANDIW_push_button_get_toggle(w) ( GANDIW_push_button_vtw(w)->toggle )
extern int GANDIW_push_button_set_toggle(GANDIW_push_button *w, int val);

#define GANDIW_push_button_getact_push(w)						( GANDIW_push_button_vtw(w)->act.push )
#define GANDIW_push_button_setact_push(w,hand)						( GANDIW_push_button_vtw(w)->act.push = (hand) )

#define GANDIW_push_button_get_toggle_attr(w)						( GANDIW_push_button_vtw(w)->toggle_attr )
extern attr_t GANDIW_push_button_set_toggle_attr(GANDIW_push_button *w,			attr_t val);

#define GANDIW_push_button_get_toggle_pair(w)						( GANDIW_push_button_vtw(w)->toggle_pair )
extern short GANDIW_push_button_set_toggle_pair(GANDIW_push_button *w,			short val);

#define GANDIW_push_button_get_win_attr(w)						( GANDIW_push_button_vtw(w)->win_attr )
extern attr_t GANDIW_push_button_set_win_attr(GANDIW_push_button *w,			attr_t val);

#define GANDIW_push_button_get_win_pair(w)						( GANDIW_push_button_vtw(w)->win_pair )
extern short GANDIW_push_button_set_win_pair(GANDIW_push_button *w, short val);

#define GANDIW_push_button_2text(w,cr)							GANDI_ch_2text_cr((cr), 1,								GANDIW_push_button_get_win_attr(							(w) ? (w) : &GANDIW_push_button_dfl ) |					COLOR_PAIR( GANDIW_push_button_get_win_pair(						(w) ? (w) : &GANDIW_push_button_dfl ) )				)

#endif /* gandiw_push_button.h */

