/* The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef _GANDIW_RADIO_BUTTON_H

#define _GANDIW_RADIO_BUTTON_H	1

#include "gandiw_text_label.h"

typedef struct _GANDIW_radio_button GANDIW_radio_button;

struct _GANDIW_radio_button {
	GANDIW_widget *		core;		/* common for all widgets */
	GANDIW_text_label *	capwid;		/* button caption */
	attr_t			win_attr;
	short			win_pair;
	bool			checked;	/* whether it's checked */
};

extern GANDIW_radio_button GANDIW_radio_button_dfl;
extern GANDIW_widget GANDIW_radio_button_dfl_core;

extern GANDIW_radio_button *GANDIW_radio_button_make(int nlines, int ncols,		int by, int bx, void *parent, const chtype *caption);
extern int GANDIW_radio_button_resize(GANDIW_radio_button *w, int nlines,		int ncols, int by, int bx);
extern void GANDIW_radio_button_refresh(GANDIW_radio_button *w);
extern void GANDIW_radio_button_set_attrs(GANDIW_radio_button *w, attr_t attr,			short pair);
extern int GANDIW_radio_button_driver(GANDIW_radio_button *w, int k);

#define GANDIW_radio_button_vtw(w)	((GANDIW_radio_button *)w)

#define GANDIW_radio_button_caption(w)							( (GANDIW_text_label *)(GANDIW_radio_button_vtw(w)->capwid) )
#define GANDIW_radio_button_get_capwid(w)	GANDIW_radio_button_caption(w)

#define GANDIW_radio_button_window(w)	GANDI_get_Nwindow(w, 0)

#define GANDIW_radio_button_draw_bullet(w) {						mvwaddstr(GANDIW_radio_button_window(w), 0, 0, "( )");				if (GANDIW_radio_button_get_checked(w))							mvwaddch(GANDIW_radio_button_window(w), 0, 1, ACS_BULLET);		wmove(GANDIW_radio_button_window(w), 0, 1); }

#define GANDIW_radio_button_get_checked(w)						( GANDIW_radio_button_vtw(w)->checked )
#define GANDIW_radio_button_set_checked(w,value) {					GANDIW_radio_button_vtw(w)->checked = value;					GANDIW_radio_button_draw_bullet(w); }

#define GANDIW_radio_button_get_win_attr(w)						( GANDIW_radio_button_vtw(w)->win_attr )
extern attr_t GANDIW_radio_button_set_win_attr(GANDIW_radio_button *w,			attr_t val);

#define GANDIW_radio_button_get_win_pair(w)						( GANDIW_radio_button_vtw(w)->win_pair )
extern short GANDIW_radio_button_set_win_pair(GANDIW_radio_button *w,			short val);

#define GANDIW_radio_button_2text(w,cr)							GANDI_ch_2text_cr((cr), 1,								GANDIW_radio_button_get_win_attr(							(w) ? (w) : &GANDIW_radio_button_dfl ) |				COLOR_PAIR( GANDIW_radio_button_get_win_pair(						(w) ? (w) : &GANDIW_radio_button_dfl ) )			)

#endif /* gandiw_radio_button.h */

